class Personnage:

    # utilisation d'un constructeur
    def __init__(self, force, localisation, experience, degats):
        """Construction d'un personnage : A = Personnage(force(int),
        localisation(str), experience(int), degats(int))"""
        self.setForce(force)
        self.setLocalisation(localisation)
        self.setExperience(experience)
        self.setDegats(degats)

    # Méthodes accesseurs (getters).
    def getForce(self):
        return self._force

    def getLocalisation(self):
        return self._localisation

    def getExperience(self):
        return self._experience

    def getDegats(self):
        return self._degats

    # Méthodes mutateurs avec assertion (setters)
    def setForce(self, valeur):
        assert (isinstance(valeur, int) and valeur >= 0 and valeur <= 100), \
            "Votre force ne convient pas !"
        self._force = valeur

    def setLocalisation(self, valeur):
        assert (isinstance(valeur, str) and len(valeur) >= 3 and len(valeur) <= 20), \
            "Votre localisation ne convient pas !"
        self._localisation = valeur

    def setExperience(self, valeur):
        assert (isinstance(valeur, int) and valeur >= 0 and valeur <= 100), \
            "Votre Experience ne convient pas !"
        self._experience = valeur

    def setDegats(self, valeur):
        assert (isinstance(valeur, int) and valeur >= 0 and valeur <= 100), \
            "Vos dégâts ne conviennent pas !"
        self._degats = valeur

    # Méthodes privées de la classe
    def __gagner_experience__(self, exp):
        assert (exp in [5, 10, 15]), \
            "Les seuls gains d'expériences possibles sont 5, 10 ou 15."
        self.setExperience(self._experience + exp)

    def __mettre_degats__(self, Perso):
        Perso.setDegats(Perso._degats + 5)

    # Méthodes publiques de la classe
    def parler(self, phrase):
        assert (isinstance(phrase, str)), \
            "Votre phrase n'en est pas une !"
        print(phrase)

    def frapper(self, Perso):
        assert (isinstance(Perso, Personnage)), \
            "Vous ne pouvez frapper qu'un personnage !"
        self.__gagner_experience__(10)
        self.__mettre_degats__(Perso)
